class Player{
  public float x;
  public float y;
  public float width;
  public float height;
  public float velocityX;
  public float velocityY;
}
PImage playerImage;
Player player;
class Input{
  public boolean space;
  public boolean left;
  public boolean right;
}
Input input;
class Block{
  public float x;
  public float y;
  public float width;
  public float height;
  public int type;
}
Block[] blocks;
class Camera{
  public float x;
  public float y;
}
Camera camera;
void setup(){
  size(600, 400);
  playerImage = loadImage("drone.png");
  player = new Player();
  player.width = 50;
  player.height = 30;
  player.x = 300 - 25;
  player.y = 200 - 15;
  input = new Input();
  blocks = new Block[50];
  blocks[0] = new Block();
  blocks[0].width = 100;
  blocks[0].height = 30;
  blocks[0].x = 300 - 50;
  blocks[0].y = 300 - 15;
  blocks[0].type = 1;
  blocks[1] = new Block();
  blocks[1].width = 50;
  blocks[1].height = 300;
  blocks[1].x = 400;
  blocks[1].y = 100;
  blocks[1].type = 2;
  blocks[2] = new Block();
  blocks[2].width = 100;
  blocks[2].height = 100;
  blocks[2].x = 500;
  blocks[2].y = 300;
  blocks[2].type = 3;
  camera = new Camera();
  camera.x = player.x - 200;
  camera.y = player.y - 200;
} 
void draw(){
  background(255);
  if(input.space){
    player.velocityY -=0.2;
  }
  if(input.left){
    player.velocityX -= 0.1;
  }
  if(input.right){
    player.velocityX += 0.1;
  }
  player.velocityY += 0.1;
  player.velocityX *= 0.98;
  float prevX = player.x;
  float prevY = player.y;
  player.y += player.velocityY;
  player.x += player.velocityX;
  for(int i = 0; i < blocks.length; i++){
    Block b = blocks[i];
    if(b != null){
      boolean isHit =
        isHit(player.x, player.y, player.width, player.height,
              b.x, b.y, b.width, b.height);
      if (b.type == 1) {
        if(isHit){
          player.x = prevX;
          player.y = prevY;
          player.velocityX = 0;
          player.velocityY = 0;
        }
        fill(0, 255, 0);
      }
      if (b.type == 2) {
        if (isHit) {
          player.x = 300 - 25;
          player.y = 200 - 15;
          player.velocityX = 0;
          player.velocityY = 0;
        }
        fill(255, 255, 0);
      }
      if (b.type == 3) {
        if (isHit) {
          player.x = prevX;
          player.y = prevY;
          player.velocityX = 0;
          player.velocityY = 0;
        }
        fill(0, 0, 255);
      }
     rect(getDisplayX(b.x), getDisplayY(b.y), b.width, b.height);
    }
  }
  image(playerImage, getDisplayX(player.x), getDisplayY(player.y),
  player.width ,player.height);
  camera.x = player.x - 200;
  camera.y = player.y - 200;
}
void keyPressed(){
  if(key == ' '){
    input.space = true;
  }
  if(keyCode == RIGHT){
    input.right = true;
  }
  if(keyCode == LEFT){
    input.left = true;
  }
}
void keyReleased(){
  if(key == ' '){
    input.space = false;
  }
  if(keyCode == RIGHT){
    input.right = false;
  }
  if(keyCode == LEFT){
    input.left = false;
  }
}
boolean isHit(float px, float py, float pw, float ph,
              float bx, float by, float bw, float bh){
  float centerPx = px + pw / 2;
  float centerPy = py + ph / 2;
  float centerBx = bx + bw / 2;
  float centerBy = by + bh / 2;
  if(abs(centerPx - centerBx) < pw / 2 + bw / 2){
    if(abs(centerPy - centerBy) < ph / 2 + bh / 2){
      return true;
    }
  }
  return false;
}
float getDisplayX(float x){
  return x - camera.x;
}
float getDisplayY(float y){
  return y - camera.y;
}
